技术胜过教条——关于开源的一些见解
============================

为何Marten Mickos 是开源领域中最受尊敬的领导者之一，本文将告诉你原因。
--------------------------------------------------------------------------------

![Technology Trumps Dogma, And Other Open Source Insights](http://readwrite.com/files/styles/630_0su/public/files/files/cloud/marten-mickos.jpg)


几周前，我拜访了Eucalyptus System的CEO Marten Mickos，想请他[就开源领域中的人员构成变化问题发表一些看法](http://readwrite.com/2013/08/27/linux-turns-22-but-open-source-is-eternal#awesm=~oh8KYvjJatv2EW)。他也确实给出了他的看法，而且是用明显的Mickos风格。

我本打算分享Mickos所有天才般的见解，但不幸的是，由于篇幅限制，很多精彩言论只能被迫砍掉。Mickos曾经帮助MySQL成为世界上最受欢迎的数据库，如今，他正尝试让一个开源云计算产品达到同样的高度。

经历过多次成功与失败后，Mickos有无数有关开源的智慧分享给我们。例如当开源开发者一直在努力回避企业对某一个开源项目的影响时，Mickos却提醒我们，金钱是至关重要的发展资金，更何况营销和文档。那种爱好和平、拒绝金钱的开源项目只能是一个神话。

**金钱对于开源的重要性...**

没有钱，开源就是死路一条。

**开源商业化战略背后的基本原则...**

有些人为了省钱浪费大把时间，有人却花钱来节约时间。

**开源开发者的人员构成变化...**

过去，开源社区的开发者们看起来都像是真正的牛仔——时刻表现出真正的自己，遵循自己的个性道路，追寻他们几乎无限的自由。今天，许多开源社区的开发者们却很乐意受雇于与开源精神相悖的大公司（例如Google，HP，IBM，Oracle等等）。当他们发表公众言论的时候，还会标明其言论仅代表自己的个人观点，并非所在公司的官方声明。和过去相比，如今自愿的服从已经很普遍。

**非盈利版权授权及管理的作用...**

FOSS（Free Open Source Software自由及开源软件）许可证及其管理模式的目的并不是为了让志趣相投的人们协作在一起，尽管它也有这个效果。FOSS是为了让意见不一致的人们在一起协作。开源的美丽就在于能够让不同的人们为相同的产品贡献代码。

**领袖...**

无论在精英制度中还是在大众生产模式中，人们都需要领袖。

**批评性意见...**

在可持续发展的基础上，如果你能真正热爱严厉的批评，如果你能对别人的贡献无论大小与类型，都真正表现出无比的热情与感激，你一定能在开源领域获得无比的成功。

当人们抱怨你的开源项目时，你只需要记住：忠言逆耳。他们其实是爱你的。

如果没有人反对你的开源产品或项目，其实你并不是真的受欢迎。[反对者恰恰是你通向成功的路标](http://readwrite.com/2013/02/25/haters-as-a-leading-indicator-of-success#awesm=~oh8MUh09kvHxy3)。


**品牌的作用...**

授权问题同时更多的是一个品牌问题。红帽将他们的开源社区冠以“Red Hat”品牌并商业化后，还建立了非商业化品牌Fedora。MySQL和JBoss却恰好相反，他们从社区到商用都使用同一个品牌。当你fork的时候，因为该品牌并未包含在开源授权许可中，所以你必须使用不同的名字。


**开源"神学"中显著的不一致性...**

开源的人可能是教条主义的，特别是对别人。出于正统或纯洁性，他们会急切的要求一些项目按照这样或那样的方式进行。但是同时他们却愉快地使用诸如iBooks这样的封闭系统，因为他们崇拜这些产品。技术胜过教条。冷静是关键。关于所有这些我所说的并不是抱怨，而是一种观察。要在开源中成功，你必须学会接受它并善加利用。

**开源过去十年来的变化...**

过去，人们不知道它是什么，如何工作，为何这么做，怎样创造出伟大的软件，为何它没有自生自灭等等。这也是为什么LAMP能够将它推向财富杂志的封面——它是如此新颖和迷人。今天，人们知道开源，还知道开源是软件世界不可或缺的一部分。过去，当权者反对它；今天，当权者拥抱它(至少假装如此)。

过去，做开源的人只有非常少的一部分人，他们关注开源本身，在博客中讨论开源的意义，思考开源的商业模式。今天，做开源的人包括程序员、社区领袖、测试人员、使用者、投资者还有作家。

过去，无论从哪方面看，授权都是很大的一个问题。今天，它只是一个话题而已。

过去，开源只涉及到少部分项目中的少部分人。今天，这类项目的数字大概增加了100-1000倍。

过去，开源的相关基础设施并不存在。今天，我们有Wiki，Github，Jira等服务，方便地告诉我们如何运行和管理一个开源项目。

十年前，人们愿意下载发行版。今天,人们上传镜像(到云端)。

**开源过去十年来未曾改变的...**

仍然有大量肆无忌惮的狂热者，他们常常已经接近“很傻很天真”的边缘，他们为开源带来令人震惊的收获，但同时也不可避免地带来一些缺点。

开源仍然吸引着优秀的天才。

最成功的开源项目往往以开发者为目标。而那些供普通消费者或非技术人员使用的产品往往并不成功。但往往也有一些著名的例外，例如Firefox,Android,也许OpenOffice也算一个。


via:http://readwrite.com/2013/09/13/marten-mickos-interview-open-source-mysql-eucalyptus

本文由 [LCTT][] 原创翻译，[Linux中国][] 荣誉推出

译者：[Mr小眼儿][] 校对：[wxy][]


[LCTT]:https://github.com/LCTT/TranslateProject
[Linux中国]:http://linux.cn/portal.php
[Mr小眼儿]:http://linux.cn/space/14801
[wxy]:http://linux.cn/space/wxy

