我成为一名软件工程师的原因和经历
==========================================

![](https://opensource.com/sites/default/files/styles/image-full-size/public/images/life/myopensourcestory.png?itok=6TXlAkFi)

1989 年乌干达首都，坎帕拉。

赞美我的父母，他们机智的把我送到叔叔的办公室，去学着用电脑，而非将我留在家里添麻烦。几日后，我和另外六、七个小孩，还有一台放置在与讲台相垂直课桌子上的崭新电脑，一起置身于 21 层楼高的狭小房间中。很明显我们还不够格去碰那家伙。在长达三周无趣的 DOS 命令学习后，终于迎来了这美妙的时光。终于轮到我来输 **copy doc.txt d:** 了。

那奇怪的声音其实是将一个简单文件写入五英寸软盘的声音，但听起来却像音乐般美妙。那段时间，这块软盘简直成为了我的至宝。我把所有我可以拷贝的东西都放在上面了。然而，1989 年的乌干达，人们的生活十分正经，相较而言捣鼓电脑，拷贝文件还有格式化磁盘就称不上正经。我不得不专注于自己的学业，这让我离开了计算机科学走入了建筑工程学。

在这些年里，我和同龄人一样，干过很多份工作也学到了许多技能。我教过幼儿园的小朋友，也教过大人如何使用软件，在服装店工作过，还在教堂中担任过付费招待。在我获取堪萨斯大学的学位时，我正在技术高管的手下做技术助理，其实也就听上去比较洋气，也就是搞搞学生数据库而已。

当我 2007 年毕业时，这些技术已经变得不可或缺。建筑工程学的方方面面都与计算机科学深深的交织在一起，所以我们也都在不经意间也都学了些简单的编程知识。我对于这方面一直很着迷。但由于我不得不成为一位正经的工程师，所以我发展了一项私人爱好：写科幻小说。

在我的故事中，我以我笔下的女英雄的形式存在。她们都是编程能力出众的科学家，总是在冒险的途中用自己的技术发明战胜那些渣渣们，有时发明要在战斗中进行。我想出的这些“新技术”，一般基于真实世界中的发明。也有些是从买来的科幻小说中读到的。这就意味着我需要了解这些技术的原理，而且我的研究使我有意无意的关注了许多有趣的 subreddit 和电子杂志

### 开源：巨大的宝库

在我的经历中，那几周花在 DOS 命令上的时间仍然记忆犹新，在一些偏门的项目上耗费心血，并占据了宝贵的学习时间。Geocities 一向所有 Yahoo! 用户开放，我就创建了一个网站，用于发布一些由我用小型数码相机拍摄的个人图片。这个网站是我随性而为的，用来帮助家人和朋友，解决一些他们所遇到的电脑问题。同时也为教堂搭建了一个图书馆数据库。

这意味着，我需要一直研究并尝试获取更多的信息，使它们变得更棒。上帝保佑，让互联网和开源砸在了我的面前。然后，30 天试用和 license 限制对我而言就变成了过去式。我可以完全不受这些限制，持续的使用 GIMP、Inkscape 和 OpenOffice。

### 是时候正经了

我很幸运，有商业伙伴看出了我故事中的奇妙。她也是个想象力丰富的人，对更高效、更便捷的互联这个世界，充满了各种美好的想法。我们根据我们以往成功道路中经历的痛点制定了解决方案，但执行却成了一个问题。我们都缺乏那种将产品带入生活的能力，每当我们试图将想法带到投资人面前时，都表现的尤为突出。

我们需要学习编程。所以在 2015 年的夏末，我们踏上了征途，来到了 Holberton 学校的阶前。那是一所座落于旧金山由社区推进，基于项目教学的学校。

我的商业伙伴一天早上找到我，并开始了一段充满她方式的对话，每当她有疯狂想法想要拉我入伙时。

**Zee**: Gloria，我想和你说点事，在拒绝前能先听我说完吗？

**Me**: 不行。

**Zee**: 我们想要申请一所学校的全栈工程师。

**Me**: 什么？

**Zee**: 就是这，看！就是这所学校，我们要申请这所学校学习编程。

**Me**: 我不明白。我们不是正在网上学 Python 和…

**Zee**: 这不一样。相信我。

**Me**: 那…

**Zee**: 还不相信吗？

**Me**: 好吧…我看看。

### 抛开偏见

我看到的和我们在网上听说的几乎差不多。这简直太棒了，以至于让人觉得不太真实，但我们还是决定尝试一下，双脚起跳，看看结果如何。

要成为学生，我们需要经历四个步骤，仅仅是针对才能和态度，无关学历和编程经历的筛选。筛选便是课程的开始，通过它我们开始学习与合作。

根据我和我合作伙伴的经验，相比 Holberton 学校的申请流程，其他的申请流程实在是太无聊了。就像场游戏。如果你完成了一项挑战，你就能通往下一关，在那里有别的有趣的挑战正等着你。我们创建了 Twitter 账号，在 Medium 上写博客，为了创建网站而学习 HTML 和 CSS， 打造了一个充满活力的社区，虽然在此之前我们并不知晓有谁会来。

在线社区最吸引人的就是我们使用电脑的经验是多种多样的，而我们的背景和性别并非创始人（我们私下里称他为“The Trinity（三位一体）”）做出选择的因素。大家只是喜欢聚在一块交流。我们都是通过学习编程来提升自己计算机技术的聪明人。

相较于其他的的申请流程，我们不需要泄露很多的身份信息。就像我的商业伙伴，她的名字里看不出她的性别和种族。直到最后一个步骤，在视频聊天的时候， The Trinity 才知道她是一位有色人种女性。迄今为止，促使她达到这个程度的只是她的热情和才华。肤色和性别，并没有妨碍或者帮助到她。还有比这更酷的吗？

那个我们获得录取通知书的晚上，我们知道我们的命运已经改变，我们获得了原先梦寐以求的生活。2016 年 1 月 22 日，我们来到北至巴特瑞大街 98 号，去见我们的小伙伴 [Hippokampoiers][2]，这是我们的初次见面。很明显，在见面之前，“The Trinity”就已经开始做一些令人激动的事了。他们已经聚集了一批形形色色的人，他们都专注于成为全栈工程师，并为之乐此不疲。

这所大学有种与众不同的体验。感觉每天都是向编程的一次竭力的冲锋。我们着手的工程，并不会有很多指导，我们需要使用一切我们可以使用的资源找出解决方案。[Holberton 学校][1] 的办学宗旨便是向学员提供，相较于我们已知而言，更为多样的信息渠道。MOOCs（大型开放式课程）、教程、可用的开源软件和项目，以及线上社区层出不穷，将我们完成项目所需要的知识全都衔接了起来。加之宝贵的导师团队来指导我们制定解决方案，这所学校变得并不仅仅是一所学校；我们已经成为了求学者的社区。任何对软件工程感兴趣并对这种学习方法感兴趣的人，我都十分推荐这所学校。下次开课在 2016 年 10 月，并且会接受新的申请。虽然会让人有些悲喜交加，但是那真的很值得。

### 开源问题

我最早使用的开源系统是 [Fedora][3]，一个 [Red Hat][4] 赞助的项目。在与 IRC 中一名成员一番惊慌失措的交流后，她推荐了这款免费的系统。 虽然在此之前，我还未独自安装过操作系统，但是这激起了我对开源的兴趣和日常使用计算机时对开源软件的依赖性。我们提倡为开源贡献代码，创造并使用开源的项目。我们的项目就在 Github 上，任何人都可以使用或是向它贡献出自己的力量。我们也会使用或以自己的方式为一些既存的开源项目做出贡献。在学校里，我们使用的大部分工具是开源的，例如 Fedora、[Vagrant][5]、[VirtualBox][6]、[GCC][7] 和 [Discourse][8]，仅举几例。

重回软件工程师之路以后，我始终憧憬着有这样一个时刻——能为开源社区做出一份贡献，能与他人分享我所掌握的知识。

### Diversity Matters

站在教室里，在着 29 双明亮的眼睛关注下交流心得，真是令人陶醉。学员中有 40% 是女性，有 44% 的有色人种。当你是一位有色人种且为女性，并身处于这个以缺乏多样而著名的领域时，这些数字就变得非常重要了。那是高科技圣地麦加上的绿洲。我知道我做到了。

想要成为一个全栈的工程师是十分困难的，你甚至很难了解这意味着什么。这是一条充满挑战的路途，道路四周布满了对收获的未知。科技推动着未来飞速发展，而你也是美好未来很重要的一部分。虽然媒体在持续的关注解决科技公司的多样化的问题，但是如果能认清自己，了解自己，知道自己为什么想成为一名全栈工程师，这样你便能觅得一处生根发芽。

不过可能最重要的是，提醒人们女性在计算机的发展史上扮演着多么重要的角色，以帮助更多的女性回归到科技界，并使她们充满期待，而非对自己的性别与能力感到犹豫。她们的才能将会描绘出不仅仅是科技的未来，而是整个世界的未来。


------------------------------------------------------------------------------

via: https://opensource.com/life/16/4/my-open-source-story-gloria-bwandungi

作者：[Gloria Bwandungi][a]
译者：[martin2011qi](https://github.com/martin2011qi)
校对：[校对者ID](https://github.com/校对者ID)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创翻译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://opensource.com/users/nappybrain
[1]: https://www.holbertonschool.com/
[2]: https://twitter.com/hippokampoiers
[3]: https://en.wikipedia.org/wiki/Fedora_(operating_system)
[4]: https://www.redhat.com/
[5]: https://www.vagrantup.com/
[6]: https://www.virtualbox.org/
[7]: https://gcc.gnu.org/
[8]: https://www.discourse.org/
