Devops的弹性合作
=================================

![](http://devops.com/wp-content/uploads/2016/05/ScalingCollaboration.jpg)

那些熟悉Devops的人普遍认同这样的文化关乎科技。当然，工具和参与是Devops有效实施的必要。但是Devops成功的基础是[团队合作][1]在企业做事更迅速，有效


大多数的DevOps平台和工具的设计具有可扩展性的理念。DevOps环境通常运行在云端，并且容易发生变化。为了支持DevOps实时规模解决需求激增，软件变得很重要。同样的事情是真实的人为因素，但缩放合作是一个完整的不同的故事。


跨企业协同是DevOps成功的关键。好的代码和发展是需要的。面临的挑战是如何做到无缝和尽可能多的速度和自动化，而不牺牲质量或性能。企业如何才能简化代码的开发和部署，同时保持知名度，治理和合规？

### 新兴趋势

首先，我先提供一些背景，分享一些通过451研究公司 关于devops的研究而获取的数据。云、敏捷和Devops 在今天是非常重要的，不管是理念还是现实。451研究公司看到企业通过这些东西，还包括容器技术、增长大量的用在生产环境中。

拥抱这些技术和方法有许多优点，比如提高灵活性和速度，降低成本，提高弹性和可靠性，适应新的或新兴的应用。根据451公司的研究，组织也面临着一些障碍，包括缺乏熟悉和所需的技能，这些新兴技术的不成熟，成本和安全问题。

在 “[Voice of the Enterprise: SDI Q4 2015 survey][2],” 451公司发行超过一半的受访者者(最后为57.1%)考虑到他们是最终调查者或新兴科技。另一方面，近半受访者（48.3 %）认为自己是第一个或早起的采用者。

这些普遍性的情绪表现在对其他问题的调查中。当问起容器的执行情况时，50.3%的人表示这不在他们的计划中。49.7%的人是在进行计划、试点或积极使用容器技术。近2/3（65.1%）的人表示，他们用敏捷开发的应用开发，但是只有39.6%的回应，他们正在积极拥抱DevOps。然而，敏捷软件开发已经在行业内存在了多年，451公司注意到通过容器和Devops的提升给他们了很现实的趋势。

当被问及首要的三个痛点是什么，被提及最多的是成本或预算，工作人员和遗留软件问题。随着企业向云，DevOps，和容器等转型，这些都需要加以解决，以及如何规模技术和协作的有效。

### 当前状况

由Devops革命在很大程度上带动产生巨大变化的行业，使得软件开发变得更加高度集成的整个业务。软件的创造是不分种族的，而且更多是协作和社会化的功能。

在推动价值的今天，几年前的概念和方法已经成熟，很快就成为今天的主流技术和框架。企业依靠如敏捷、精益、虚拟化、云计算、自动化等概念来简化开发，同时使工作更加有效。

为适应和发展，企业需要完成一系列的关键任务。当今面临的挑战是如何加快发展的同时降低成本。组织需要消除它和其他业务之间存在的障碍，并在一个由技术驱动的竞争环境中提供更多有效的战略合作。

敏捷、云计算、Devops和容器在这个过程中起着重要的作用，但是有一件事情，他们都是有效的合作。每一种技术和方法都提供了独特的优势，但真正的价值来自于组织的整体能够进行规模协同和组织所使用的工具和平台。成功的DevOps的实现也需要其他利益相关者的参与，发展IT运营团队，包括安全、数据库、存储和业务队伍。

### 合作即平台

有一些在线的服务和平台，比如Github,促进了流式合作。它的功能是一个在线代码库，但是所产生的价值远超出了存储代码。


这样一个[协作平台][4] 有助于开发人员和团队合作，因为它提供了一个代码和程序的社区可以共享和讨论。管理者可以监视进度和跟踪下一个代码是什么开发人员可以在一个安全的环境中进行实验，然后把这些实验的生活环境，新的想法和实验可以有效地传达给适当的团队。

更敏捷开发和DevOps的关键之一是允许开发人员测试并收集相关的快速反馈。目标是生产高质量的代码和功能，而不是浪费时间建立和管理基础设施或者安排更多的会议来讨论这个问题。比如GitHub平台，能够更有效的和可扩展的协作是因为代码审查可以由参与者最方便的进行。没有必要尝试协调和安排代码审查会议，使开发人员可以继续不间断地工作，从而产生更大的生产力和工作满意度。

Sendachi的Steven Anderson 指出，Github是一个协作平台，但它也是一个和你一起工作的工具。这样意味着他不仅可以帮助协作和持续集成，还影响了代码质量

合作平台的好处之一是，大型团队的开发人员可以分解成更小的团队，可以更有效地专注于特定的组件。它还允许诸如文件共享、模糊代码开发技术和非技术的贡献，增加了协作和可见性

### 合作是关键

合作的重要性不言而喻。合作是Devops文化的关键，也是当今世界能够进行敏捷开发和保持竞争优势的重要的一点。执行或管理的支持以及内部的传道是很重要的。组织还需要拥抱文化的转变---朝着目标混合技能跨越职能领域

当这样的文化建立起来，有效的合作是至关重要的。一个合作平台是规模合作的必要组件，因为简化了生产活动，并且减少了冗余和尝试，同时还产生了更高质量的结果。


--------------------------------------------------------------------------------

via: http://devops.com/2016/05/16/scaling-collaboration-devops/

作者：[TONY BRADLEY][a]
译者：[Bestony](https://github.com/Bestony)
校对：[校对者ID](https://github.com/校对者ID)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]: http://devops.com/author/tonybsg/
[1]: http://devops.com/2014/12/15/four-strategies-supporting-devops-collaboration/
[2]: https://451research.com/
[3]: https://451research.com/customer-insight-voice-of-the-enterprise-overview
[4]: http://devops.com/events/analytics-of-collaboration-on-github/
